import { computed as f, ref as k, watch as E, onMounted as X, openBlock as n, createElementBlock as u, normalizeStyle as g, createElementVNode as c, toDisplayString as _, createCommentVNode as y, unref as b, Fragment as D, renderList as P, normalizeClass as N, createBlock as W } from "vue";
import { u as J, c as I, t as K, a as Q, p as i, d as C, b as R, o as Y, e as U, g as Z, f as O, X as ee, s as te, w as le, i as ae } from "./index-Ca4RHJ4t.js";
import { u as V } from "./useNestedProp-vP7uimPz.js";
import oe from "./vue-ui-skeleton-D7aLznpP.js";
import { _ as se } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const ne = ["xmlns", "viewBox"], re = ["id"], ue = ["stop-color"], ie = ["stop-color"], ce = ["stop-color"], de = {
  id: "stackPill",
  clipPathUnits: "objectBoundingBox"
}, ve = ["fill"], ge = { "clip-path": "url(#stackPill)" }, pe = ["height", "width", "fill"], he = ["onClick", "x", "width", "height", "fill", "stroke"], fe = ["onClick"], ye = { style: { display: "flex", "flex-direction": "row", "align-items": "center", gap: "4px", "justify-content": "center" } }, me = ["height", "width"], ke = ["fill"], _e = {
  __name: "vue-ui-sparkstackbar",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  emits: ["selectDatapoint"],
  setup(G, { emit: M }) {
    const r = G, { vue_ui_sparkstackbar: T } = J(), z = f(() => !!r.dataset && r.dataset.length), A = k(I()), e = f({
      get: () => L(),
      set: (t) => t
    });
    function L() {
      const t = V({
        userConfig: r.config,
        defaultConfig: T
      });
      return t.theme ? {
        ...V({
          userConfig: K.vue_ui_sparkstackbar[t.theme] || r.config,
          defaultConfig: t
        }),
        customPalette: Q[t.theme] || i
      } : t;
    }
    E(() => r.config, (t) => {
      e.value = L(), B();
    }, { deep: !0 }), E(() => r.dataset, (t) => {
      p.value = r.dataset.map((a, l) => ({
        ...a,
        color: a.color ? C(a.color) : x.value[l] || i[l] || i[l % i.length]
      }));
    }, { deep: !0 });
    const x = f(() => R(e.value.customPalette)), p = k(r.dataset.map((t, a) => ({
      ...t,
      value: e.value.style.animation.show ? 0 : t.value || 0,
      color: t.color ? C(t.color) : x.value[a] || i[a] || i[a % i.length]
    }))), w = k(!0);
    X(() => {
      if (B(), e.value.style.animation.show) {
        let h = function() {
          o += l / t, o < l ? (p.value = p.value.map((s, d) => ({
            ...s,
            value: s.value += a[d],
            color: s.color ? C(s.color) : x.value[d] || i[d] || i[d % i.length]
          })), requestAnimationFrame(h)) : (w.value = !1, p.value = r.dataset.map((s, d) => ({
            ...s,
            value: s.value || 0,
            color: s.color ? C(s.color) : x.value[d] || i[d] || i[d % i.length],
            id: I()
          })));
        };
        const t = e.value.style.animation.animationFrames, a = r.dataset.map((s, d) => s.value / t), l = r.dataset.map((s) => s.value || 0).reduce((s, d) => s + d, 0);
        let o = 0;
        w.value = !0, h();
      }
    });
    function B() {
      Y(r.dataset) ? U({
        componentName: "VueUiSparkStackbar",
        type: "dataset"
      }) : r.dataset.forEach((t, a) => {
        Z({
          datasetObject: t,
          requiredAttributes: ["name", "value"]
        }).forEach((l) => {
          U({
            componentName: "VueUiSparkStackbar",
            type: "datasetSerieAttribute",
            property: l,
            index: a
          });
        });
      });
    }
    const m = k({
      width: 500,
      height: 16
    }), v = k([]), q = f(() => r.dataset.map((t) => t.value || 0).filter((t, a) => !v.value.includes(a)).reduce((t, a) => t + a, 0)), F = f(() => p.value.map((t, a) => {
      const l = t.value || 0, o = l / q.value, h = isNaN(o) ? 0 : o, s = h * m.value.width;
      return {
        ...t,
        value: l,
        proportion: h,
        width: s || m.value.width / p.value.length,
        proportionLabel: O({
          v: h * 100,
          s: "%",
          r: e.value.style.legend.percentage.rounding
        })
      };
    })), $ = f(() => F.value.filter((t, a) => !v.value.includes(a)));
    function H(t) {
      v.value.includes(t) ? v.value = v.value.filter((a) => a !== t) : v.value.length < p.value.length - 1 && v.value.push(t);
    }
    const S = f(() => {
      let t = 0;
      const a = [];
      for (let l = 0; l < $.value.length; l += 1)
        a.push({
          ...$.value[l],
          start: t
        }), t += $.value[l].width;
      return a;
    });
    function j(t, a) {
      M("selectDatapoint", { datapoint: t, index: a });
    }
    return (t, a) => (n(), u("div", {
      style: g(`width:100%; background:${e.value.style.backgroundColor}`)
    }, [
      e.value.style.title.text ? (n(), u("div", {
        key: 0,
        style: g(`width:calc(100% - 12px);background:transparent;margin:0 auto;margin:${e.value.style.title.margin};padding: 0 6px;text-align:${e.value.style.title.textAlign}`)
      }, [
        c("div", {
          style: g(`font-size:${e.value.style.title.fontSize}px;color:${e.value.style.title.color};font-weight:${e.value.style.title.bold ? "bold" : "normal"}`)
        }, _(e.value.style.title.text), 5),
        e.value.style.title.subtitle.text ? (n(), u("div", {
          key: 0,
          style: g(`font-size:${e.value.style.title.subtitle.fontSize}px;color:${e.value.style.title.subtitle.color};font-weight:${e.value.style.title.subtitle.bold ? "bold" : "normal"}`)
        }, _(e.value.style.title.subtitle.text), 5)) : y("", !0)
      ], 4)) : y("", !0),
      z.value ? (n(), u("svg", {
        key: 1,
        xmlns: b(ee),
        width: "100%",
        viewBox: `0 0 ${m.value.width} ${m.value.height}`
      }, [
        c("defs", null, [
          (n(!0), u(D, null, P(S.value, (l, o) => (n(), u("linearGradient", {
            key: `stack_gradient_${o}`,
            gradientTransform: "rotate(90)",
            id: `stack_gradient_${o}_${A.value}`
          }, [
            c("stop", {
              offset: "0%",
              "stop-color": l.color
            }, null, 8, ue),
            c("stop", {
              offset: "50%",
              "stop-color": b(te)(b(le)(l.color, 0.05), 100 - e.value.style.bar.gradient.intensity)
            }, null, 8, ie),
            c("stop", {
              offset: "100%",
              "stop-color": l.color
            }, null, 8, ce)
          ], 8, re))), 128)),
          c("clipPath", de, [
            c("rect", {
              x: "0.005",
              y: "-2",
              width: "0.99",
              height: "5",
              rx: "3",
              ry: "3",
              fill: e.value.style.backgroundColor
            }, null, 8, ve)
          ])
        ]),
        c("g", ge, [
          c("rect", {
            x: 0,
            y: 0,
            height: m.value.height,
            width: S.value.map((l) => l.width).reduce((l, o) => l + o, 0),
            fill: e.value.style.bar.gradient.underlayerColor,
            class: N({ animated: !w.value })
          }, null, 10, pe),
          (n(!0), u(D, null, P(S.value, (l, o) => (n(), u("rect", {
            key: `stack_${o}`,
            onClick: () => j(l, o),
            x: l.start,
            y: 0,
            width: l.width,
            height: m.value.height,
            fill: e.value.style.bar.gradient.show ? `url(#stack_gradient_${o}_${A.value})` : l.color,
            stroke: e.value.style.backgroundColor,
            "stroke-linecap": "round",
            class: N({ animated: !w.value })
          }, null, 10, he))), 128))
        ])
      ], 8, ne)) : y("", !0),
      z.value ? y("", !0) : (n(), W(oe, {
        key: 2,
        config: {
          type: "sparkStackbar",
          style: {
            backgroundColor: e.value.style.backgroundColor,
            sparkStackbar: {
              color: "#CCCCCC"
            }
          }
        }
      }, null, 8, ["config"])),
      e.value.style.legend.show ? (n(), u("div", {
        key: 3,
        style: g(`background:transparent;margin:0 auto;margin:${e.value.style.legend.margin};justify-content:${e.value.style.legend.textAlign === "left" ? "flex-start" : e.value.style.legend.textAlign === "right" ? "flex-end" : "center"}`),
        class: "vue-ui-sparkstackbar-legend"
      }, [
        (n(!0), u(D, null, P(F.value, (l, o) => (n(), u("div", {
          style: g(`font-size:${e.value.style.legend.fontSize}px;`),
          class: N({ "vue-ui-sparkstackbar-legend-item": !0, "vue-ui-sparkstackbar-legend-item-unselected": v.value.includes(o) }),
          onClick: (h) => {
            H(o), j(l, o);
          }
        }, [
          c("div", ye, [
            (n(), u("svg", {
              height: `${e.value.style.legend.fontSize}px`,
              width: `${e.value.style.legend.fontSize}px`,
              viewBox: "0 0 10 10"
            }, [
              c("circle", {
                cx: 5,
                cy: 5,
                r: 5,
                fill: l.color
              }, null, 8, ke)
            ], 8, me)),
            c("span", {
              style: g(`color:${e.value.style.legend.name.color}; font-weight:${e.value.style.legend.name.bold ? "bold" : "normal"}`)
            }, _(l.name), 5),
            e.value.style.legend.percentage.show ? (n(), u("span", {
              key: 0,
              style: g(`font-weight:${e.value.style.legend.percentage.bold ? "bold" : "normal"};color:${e.value.style.legend.percentage.color}`)
            }, _(v.value.includes(o) ? " - " : l.proportionLabel), 5)) : y("", !0),
            e.value.style.legend.value.show ? (n(), u("span", {
              key: 1,
              style: g(`font-weight:${e.value.style.legend.value.bold ? "bold" : "normal"};color:${e.value.style.legend.value.color}`)
            }, " (" + _(b(ae)(
              e.value.style.legend.value.formatter,
              l.value,
              b(O)({
                p: e.value.style.legend.value.prefix,
                v: l.value,
                s: e.value.style.legend.value.suffix,
                r: e.value.style.legend.value.rounding
              }),
              { datapoint: l, seriesIndex: o }
            )) + ") ", 5)) : y("", !0)
          ])
        ], 14, fe))), 256))
      ], 4)) : y("", !0)
    ], 4));
  }
}, Se = /* @__PURE__ */ se(_e, [["__scopeId", "data-v-5b2aebbd"]]);
export {
  Se as default
};
